<template>
  <div class="sw-login" @keyup.enter="invokeLogin">
    <SwPluginSlot name="login-form-before" />
    <div class="form sw-login__form">
      <SwErrorsList :list="loginErrors" />
      <SwInput
        v-model="email"
        name="loginEmail"
        :label="$t('Your email')"
        class="sw-form__input"
        type="email"
        :valid="!$v.email.$error"
        :disabled="isLoading"
        :error-message="$t('Email is required')"
        data-testid="email-input"
        @blur="$v.email.$touch()"
      />
      <SwInput
        v-model="password"
        name="loginPassword"
        :label="$t('Password')"
        type="password"
        class="sw-form__input"
        :valid="!$v.password.$error"
        :disabled="isLoading"
        :error-message="$t('Password is required')"
        data-testid="password-input"
        @blur="$v.password.$touch()"
      />
      <SfCheckbox
        v-if="videoAndAudioSetting"
        class="sw-form__input"
        v-model="acceptance"
        name="checkbox"
      >
        <template #label>
          <span class="sf-checkbox__label" v-html="$t('I accept the privacy policy of daily.co')" />
        </template>
      </SfCheckbox>
      <!-- here -->
      <SwPluginSlot name="login-form-button">
        <SwButton
          class="sf-button--full-width sw-form__button"
          :disabled="isLoading || $v.$invalid"
          data-testid="submit-login-button"
          @click="invokeLogin"
        >
          {{ $t("Log in") }}
        </SwButton>
      </SwPluginSlot>
    </div>
  </div>
</template>

<script>
import { SfAlert } from "@storefront-ui/vue"
import useVuelidate from "@vuelidate/core"
import { required, email } from "@vuelidate/validators"
import { useUser, useSessionContext } from "@shopware-pwa/composables"
import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
import SwButton from "@/components/atoms/SwButton.vue"
import SwInput from "@/components/atoms/SwInput.vue"
import { computed, reactive, toRefs, ref } from "@vue/composition-api"
import SwErrorsList from "@/components/SwErrorsList.vue"
import { SfCheckbox } from "@storefront-ui/vue"
import { useAppointment } from "../logic/composables/useAppointment";

export default {
  name: "SwLogin",
  components: { SwButton, SfCheckbox, SwInput, SfAlert, SwPluginSlot, SwErrorsList },
  setup(props, { root }) {
    const { login, loading, errors } = useUser()
    const { videoAndAudioSetting } = useAppointment();
    const { refreshSessionContext } = useSessionContext()
    const loginErrors = computed(() => errors.login || [])
    const state = reactive({
      email: "",
      password: "",
      acceptance: false
    })

    const rules = {
      email: {
        required,
        email,
      },
      password: {
        required,
      },
      acceptance: {
        checked: value => {
          if (!videoAndAudioSetting.value) {
            return true;
          } else {
            return value === true
          }
        }
      }
    }

    const $v = useVuelidate(rules, state)

    return {
      clientLogin: login,
      isLoading: loading,
      loginErrors,
      videoAndAudioSetting,
      refreshSessionContext,
      $v,
      ...toRefs(state),
    }
  },
  methods: {
    async invokeLogin() {
      this.$v.$touch()
      if (this.$v.$invalid) {
        return
      }
      const loggedIn = await this.clientLogin({
        username: this.email,
        password: this.password,
      })
      if (loggedIn) {
        this.$emit("success")
        this.refreshSessionContext()
      }
    },
  },
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/forms";

.sw-login {
  &__alert {
    margin-bottom: var(--spacer-base);
  }
}
</style>
